/////////////////
// REVIEW PAGE //
/////////////////

$(function()
{
	if (DEFINE_INTERFACE == "ZKTECO")
	{
		//No cargamos traducciones ni header. 
		$("#htmlcentral").width(1800);
	}
	else
	{
		Init_translate();
		make_header("review");
	}
	$("#lbfromdate").text(DevExpress.localization.formatMessage("From date"));
	$("#lbtodate").text(DevExpress.localization.formatMessage("To date"));
	$("#lbplate").text(DevExpress.localization.formatMessage("Plate"));
	$("#lblist").text(DevExpress.localization.formatMessage("List"));
	$("#shnumreg").text(DevExpress.localization.formatMessage("Show num registers:"));
	$("#lbdirection").text(DevExpress.localization.formatMessage("Direction"));
	if (DEFINE_INTERFACE == "ZKTECO")
	{
		//No hacemos nada
	}
	else
	{
		set_rcpopup();
	}
	var priorities = [DevExpress.localization.formatMessage("All"), DevExpress.localization.formatMessage("In list"), DevExpress.localization.formatMessage("Not in list")];
	var sellist = 0;
	var dateact = new Date();
	var dateiniday;
	var dateendday;
	var results = [];
	var dictlist = {};
	var dict = {};
	var listas = [];
	var d2;
	var mostrarAnterior = false;
	var mostrarPosterior = false;
	var num_registros_consulta = 0;
	var num_pages = 0;
	var page_actual = 0;
	var id_inicial = 0;
	var id_final = 0;
	var num_regs = 10;
	var dir_selected = DevExpress.localization.formatMessage("(All Directions)");
	var application = "";
	var debugoptions = false;
	var json_data;

	var actual_date;
	var sortby_data="timestamp";
	var sortby_order="sortdesc";
	var lastsort = "timestamp";
	var repeat_idx = 0;
	$.urlParam = function(name)
	{
		var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
		if (results == null)
		{
			return null;
		}
		else
		{
			return results[1] || 0;
		}
	}
	
	if ($.urlParam('debugoptions') != null && $.urlParam('debugoptions') == 1)
	{
		debugoptions = true;
	}
	
	String.prototype.includes = function(str)
	{
		var returnValue = false;
		if (this.indexOf(str) !== -1)
		{
			returnValue = true;
		}
		return returnValue;
	}
	
	//GET TIME
	$.ajax(
	{
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=gettime&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
		async: false,
		success: function(data)
		{
			CheckTokenValidity(data);
			d2 = new Date(data);
			dateiniday = new Date(d2.getFullYear(), d2.getMonth(), d2.getDate(), 0, 0, 0);
			dateendday = new Date(d2.getFullYear(), d2.getMonth(), d2.getDate(), 23, 59, 59);
		}
	});
	
	$.ajax(
	{
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getconfig&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
		async: false,
		success: function(data)
		{
			CheckTokenValidity(data);
			$.each(data[1], function(i, item)
			{
				dict[item.id] = item.description;
			});
			$.each(data[0], function(i, item)
			{
				var elem = {};
				elem["ID"] = item.id;
				elem["description"] = item.description;
				listas.push(elem);
				dictlist["[" + item.id + "]"] = item.description;
			});
		}
	});
	
	//Get application value
	$.ajax(
	{
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfgeneral&camp0=name&comp0=equal&value0=aplication&maxvalues=1" + localStorage.getItem("TOKEN"),
		async: false,
		success: function(data)
		{
			application = data[0]["value"];
		}
	});
	var fdata1 = $("#data1").dxDateBox(
	{
		type: "datetime",
		displayFormat: "dd/MM/yyyy HH:mm:ss",
		value: dateiniday
	}).dxDateBox('instance');
	var fdata2 = $("#data2").dxDateBox(
	{
		type: "datetime",
		displayFormat: "dd/MM/yyyy HH:mm:ss",
		value: dateendday
	}).dxDateBox('instance');
	var fentitat = $("#TxPlate").dxTextBox();
	var fdir = $("#TxDir").dxTextBox();
	var paginitas = $("#paginitas").dxTextBox(
	{
		readOnly: true,
		width: 120,
		value: ""
	});
	$("#radio-group-simple").dxSelectBox(
	{
		dataSource: new DevExpress.data.ArrayStore(
		{
			data: listas,
			key: "ID"
		}),
		displayExpr: "description",
		valueExpr: "ID",
		value: listas[0].ID,
	});
	var itemsNumReg = [10, 20, 50, 100];
	if (DEFINE_INTERFACE == "ZKTECO")
	{
		itemsNumReg = [5];
	}
	$("#numreg").dxSelectBox(
	{
		items: itemsNumReg,
		value: itemsNumReg[0]
	});
	//direction filter
	var itemsDirList = [DevExpress.localization.formatMessage("(All Directions)"), DevExpress.localization.formatMessage("Coming"), DevExpress.localization.formatMessage("No Direction"), DevExpress.localization.formatMessage("Going")];
	if (DEFINE_INTERFACE != "ZKTECO")
	{
		$("#dirlist").dxSelectBox(
		{
			items: itemsDirList,
			value: itemsDirList[0]
		});
	}
	$("#medium-indicator").dxLoadIndicator(
	{
		height: 40,
		width: 40
	});
	$("#medium-indicator").hide();
	$("#export").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("ExportBut"),
		onClick: function()
		{
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
			var i_dir_selected = 0;
			if (DEFINE_INTERFACE != "ZKTECO")
			{
				dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
				if (dir_selected == DevExpress.localization.formatMessage("Coming"))
				{
					i_dir_selected = 1;
				}
				else if (dir_selected == DevExpress.localization.formatMessage("Going"))
				{
					i_dir_selected = -1;
				}
			}
			if (plate != "")
			{
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2)
			{
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
				i++;
			}
			if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
			{
				moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
			}
			if (debugoptions)
			{
				moreparams += "&debugoptions=1"
			}
			var win = window.open(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=exportresults&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN"), '_blank');
			if (win)
			{
				//Browser has allowed it to be openedd
				win.focus();
			}
			else
			{
				//Browser has blocked it
				alert('Please allow popups for this website');
			}
			//window.location=pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=exportresults&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(fdata2.option('value')) + moreparams + "&date="+ getStringNormalDate(new Date());
		}
	});
	$("#FirstPage").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("First page"),
		onClick: function(data2)
		{
			sortby_data = $('#FirstPage').attr("sortby");
			console.log("sortby " + sortby_data);
			if(sortby_data == lastsort){
				if(sortby_order == "sortdesc")
					sortby_order = "sortasc"
				else if(sortby_order == "sortasc")
					sortby_order = "sortdesc"
			}else{
				sortby_order="sortdesc";
			}
			lastsort = sortby_data;
			console.log("test: "+ sortby_order + " = " + sortby_data);
			page_actual = 1;
			$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
			var i_dir_selected = 0;
			if (DEFINE_INTERFACE != "ZKTECO")
			{
				dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
				if (dir_selected == DevExpress.localization.formatMessage("Coming"))
				{
					i_dir_selected = 1;
				}
				else if (dir_selected == DevExpress.localization.formatMessage("Going"))
				{
					i_dir_selected = -1;
				}
			}
			if (plate != "")
			{
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2)
			{
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
				i++;
			}
			if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
			{
				moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
			}
			$.ajax(
			{
				dataType: "json",
				async: false,
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&maxvalues=" + num_regs + "&offset=" + ((page_actual - 1) * num_regs) + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option("dataSource", data);
				}
			});
		}
	});
	$("#LastPage").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("Last page"),
		onClick: function(data2)
		{
			page_actual = num_pages;
			$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
			var i_dir_selected = 0;
			if (DEFINE_INTERFACE != "ZKTECO")
			{
				dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
				if (dir_selected == DevExpress.localization.formatMessage("Coming"))
				{
					i_dir_selected = 1;
				}
				else if (dir_selected == DevExpress.localization.formatMessage("Going"))
				{
					i_dir_selected = -1;
				}
			}
			if (plate != "")
			{
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2)
			{
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
				i++;
			}
			if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
			{
				moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
			}
			$.ajax(
			{
				dataType: "json",
				async: false,
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&maxvalues=" + num_regs + "&offset=" + ((page_actual - 1) * num_regs) + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option("dataSource", data);
				}
			});
		}
	});
	$("#PageAnt").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("<< Before"),
		onClick: function(data2)
		{
			if (page_actual > 1)
			{
				page_actual--;
			}
			$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
			var i_dir_selected = 0;
			if (DEFINE_INTERFACE != "ZKTECO")
			{
				dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
				if (dir_selected == DevExpress.localization.formatMessage("Coming"))
				{
					i_dir_selected = 1;
				}
				else if (dir_selected == DevExpress.localization.formatMessage("Going"))
				{
					i_dir_selected = -1;
				}
			}
			if (plate != "")
			{
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2)
			{
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
				i++;
			}
			if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
			{
				moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
			}
			$.ajax(
			{
				dataType: "json",
				async: false,
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&maxvalues=" + num_regs + "&offset=" + ((page_actual - 1) * num_regs) + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option("dataSource", data);
				}
			});
		}
	});
	$("#PageSig").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("Next >>"),
		onClick: function(data2)
		{
			if (page_actual < num_pages)
			{
				page_actual++;
			}
			$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
			var i = 1;
			var moreparams = "";
			var plate = $('#TxPlate').dxTextBox('instance').option('value');
			var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
			var i_dir_selected = 0;
			if (DEFINE_INTERFACE != "ZKTECO")
			{
				dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
				if (dir_selected == DevExpress.localization.formatMessage("Coming"))
				{
					i_dir_selected = 1;
				}
				else if (dir_selected == DevExpress.localization.formatMessage("Going"))
				{
					i_dir_selected = -1;
				}
			}
			if (plate != "")
			{
				moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
				i++;
			}
			if (list != -2)
			{
				moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
				i++;
			}
			if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
			{
				moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
			}
			$.ajax(
			{
				dataType: "json",
				async: false,
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&maxvalues=" + num_regs + "&offset=" + ((page_actual - 1) * num_regs) + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option("dataSource", data);
				}
			});
		}
	});
	$("#PageAnt").hide();
	$("#PageSig").hide();
	$("#paginitas").hide();
	$("#FirstPage").hide();
	$("#LastPage").hide();
	var dir_visible = true;
	if (application == "eVivotek" || application == "eFastEdgeVivotek")
	{
		$("#lbdirection").hide();
		$("#dirlist").hide();
		dir_visible = false;
	}
	$("#icon-done_info").dxButton(
	{
		type: "success",
		height: 40,
		text: DevExpress.localization.formatMessage("Search"),
		onClick: function(data2)
		{
			if (fdata1.option('value') > fdata2.option('value'))
			{
				DevExpress.ui.dialog.alert(DevExpress.localization.formatMessage("The 'from date' can not be greater than  'to date'"));
			}
			else
			{

				$('#dx-col-1').attr('onclick','$("#FirstPage").attr("sortby", "id"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-2').attr('onclick','$("#FirstPage").attr("sortby", "timestamp"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-3').attr('onclick','$("#FirstPage").attr("sortby", "numberplate"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-4').attr('onclick','$("#FirstPage").attr("sortby", "laneid"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-5').attr('onclick','$("#FirstPage").attr("sortby", "direction"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-6').attr('onclick','$("#FirstPage").attr("sortby", "globalconfidence"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-7').attr('onclick','$("#FirstPage").attr("sortby", "country"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-8').attr('onclick','$("#FirstPage").attr("sortby", "listid"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-9').attr('onclick','$("#FirstPage").attr("sortby", "imageretailpath"); $("#FirstPage").trigger("click"); return false;');
				$('#dx-col-10').attr('onclick','$("#FirstPage").attr("sortby", "imagepath"); $("#FirstPage").trigger("click"); return false;');

				var date_now = new Date();
				var date_search = new Date(fdata2.option('value'));
				if(date_search > date_now){
					console.log("Date to use: " + date_now);
					actual_date = date_now;
				}else{
					console.log("Date to use: " + date_search);
					actual_date = date_search;
				}
				var i = 1;
				var moreparams = "";
				var plate = $('#TxPlate').dxTextBox('instance').option('value');
				var list = $("#radio-group-simple").dxSelectBox('instance').option('value');
				num_regs = $("#numreg").dxSelectBox('instance').option('value');
				var i_dir_selected = 0;
				var show_results = false;
				var json_parse = true;
				if (DEFINE_INTERFACE != "ZKTECO")
				{
					dir_selected = $("#dirlist").dxSelectBox('instance').option('value');
					if (dir_selected == DevExpress.localization.formatMessage("Coming"))
					{
						i_dir_selected = 1;
					}
					else if (dir_selected == DevExpress.localization.formatMessage("Going"))
					{
						i_dir_selected = -1;
					}
				}
				data2.component.option("text", DevExpress.localization.formatMessage("Searching"));
				$("#medium-indicator").show();
				if (plate != "")
				{
					moreparams = "&camp" + i + "=numberplate&comp" + i + "=like&value" + i + "=" + plate;
					i++;
				}
				if (list != -2)
				{
					moreparams += "&camp" + i + "=listid&comp" + i + "=equal&value" + i + "=[" + list + "]";
					i++;
				}
				if (dir_selected != DevExpress.localization.formatMessage("(All Directions)"))
				{
					moreparams += "&camp" + i + "=direction&comp" + i + "=equal&value" + i + "=" + i_dir_selected;
				}
				$("#PageSig").hide();
				$("#PageAnt").hide();
				$("#paginitas").hide();
				$("#FirstPage").hide();
				$("#LastPage").hide();
				$.ajax(
				{
					async: false,
					url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=count&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&date=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
					success: function(data)
					{
						CheckTokenValidity(data);
						num_registros_consulta = data;
					}
				});
				if (num_registros_consulta > 0)
				{
					var url_data = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlresult&camp0=timestamp&comp0=between&value0=" + getStringNormalDate(fdata1.option('value')) + ";" + getStringNormalDate2(actual_date) + moreparams + "&maxvalues=" + num_regs + "&date=" + getStringNormalDate(new Date()) + "&" + sortby_order + "=" + sortby_data + localStorage.getItem("TOKEN");
					$.ajax(
					{
						dataType: "json",
						url: url_data,
						jsonp: false,
						timeout: 10000,
						cache: false,
						dataFilter: function(data, type)
						{
							CheckTokenValidity(data);
							try
							{
								console.log(JSON.parse(data));
							}
							catch (e)
							{
								data2.component.option("text", DevExpress.localization.formatMessage("Search"));
								$("#medium-indicator").hide();
								json_parse = false;
								if (DEFINE_INTERFACE == "ZKTECO")
								{
									confirm(DevExpress.localization.formatMessage("Cannot obtain the results"));
								}
								else
								{
									DevExpress.ui.notify(DevExpress.localization.formatMessage("Cannot obtain the results"), "error", 1500);
									DevExpress.ui.notify(e.name + ": " + e.message, "error", 1500);
								}
							}
							if (json_parse)
							{
								json_data = JSON.parse(data);
							}
						},
						success: function(data, text_status, query)
						{
							show_results = true;
						},
						error: function(query, error_text_status, error_thrown)
						{
							if (error_text_status == "parsererror")
							{
								show_results = true;
								repeat_idx = 0;
							}
							else
							{
								if (repeat_idx < 5)
								{
									repeatSearchRequest(url_data);
									repeat_idx = repeat_idx + 1;
								}
								else
								{
									repeat_idx = 0;
									DevExpress.ui.notify(DevExpress.localization.formatMessage("Cannot obtain the results"), "error", 1500);
								}
							}
						},
						complete: function(query, text_status)
						{
							data2.component.option("text", DevExpress.localization.formatMessage("Search"));
							$("#medium-indicator").hide();
							if (show_results)
							{
								var dataGrid;
								if ($('#gridContainerReview').length == 0)
								{
									dataGrid = $('#gridContainer').dxDataGrid('instance');
								}
								else
								{
									dataGrid = $('#gridContainerReview').dxDataGrid('instance');
								}
								dataGrid.option('paging.pageSize', num_regs);
								page_actual = 1;
								num_pages = Math.ceil(num_registros_consulta / num_regs);
								$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
								if (num_pages > 1)
								{
									$("#PageAnt").show();
									$("#PageSig").show();
									$("#paginitas").show();
									$("#FirstPage").show();
									$("#LastPage").show();
								}
								dataGrid.option("dataSource", json_data);
							}
						}
					});
				}
				else
				{
					data2.component.option("text", DevExpress.localization.formatMessage("Search"));
					$("#medium-indicator").hide();
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option("dataSource", []);
				}
			}
		}
	});
	var gridName = "#gridContainerReview";
	if ($(gridName).length == 0)
	{
		gridName = "#gridContainer";
	}
	$(gridName).dxDataGrid(
	{
		dataSource: results,
		showBorders: true,
		showRowLines: true,
		keyExpr: "id",
		hoverStateEnabled: true,
		searchPanel:
		{
			visible: true,
			width: 240,
			placeholder: DevExpress.localization.formatMessage("Search...")
		},
		pager:
		{
			visible: false
		},
		onToolbarPreparing: function(e)
		{
			var dataGrid = e.component;
			if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "AXIS" || DEFINE_INTERFACE == "VICON")
			{
				return;
			}
			e.toolbarOptions.items.unshift(
			{
				location: "center",
				widget: "dxTextBox",
				width: 120,
				readOnly: true,
				template: function()
				{
					var div = $("<div/>");
					div.attr('id', 'paginitas');
					div.dxTextBox(
					{
						readOnly: true,
						width: 120,
						value: ""
					});
					div.hide();
					return div;
				}
			});
		},
		columns: [
		{
			dataField: "id",
			caption: "ID",
			width: 80,
			calculateSortValue: function (rowData) {
				$('#dx-col-1').attr('onclick','$("#FirstPage").attr("sortby", "id"); $("#FirstPage").trigger("click"); return false;');
                return rowData.id;
            }
		},
		{
			dataField: "timestamp",
			dataType: "date",
			caption: DevExpress.localization.formatMessage("Time"),
			width: 180,
			format: "HH:mm:ss.SSS dd/MM/yyyy",
			calculateSortValue: function (rowData) {
				$('#dx-col-2').attr('onclick','$("#FirstPage").attr("sortby", "timestamp"); $("#FirstPage").trigger("click"); return false;');
                return rowData.timestamp;
            }
		},
		{
			width: 100,
			dataField: "numberplate",
			caption: DevExpress.localization.formatMessage("Plate"),
			calculateSortValue: function (rowData) {
				$('#dx-col-3').attr('onclick','$("#FirstPage").attr("sortby", "numberplate"); $("#FirstPage").trigger("click"); return false;');
                return rowData.numberplate;
            }
		},
		{
			width: 80,
			dataField: "laneid",
			caption: DevExpress.localization.formatMessage("Lane"),
			cellTemplate: function(element, info)
			{
				if (info.text == 0)
				{
					element.append("");
				}
				else
				{
					if (info.text % 2 == 0)
					{
						element.append(DevExpress.localization.formatMessage("LANE 1"));
					}
					else
					{
						element.append(DevExpress.localization.formatMessage("LANE 2"));
					}
				}
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-4').attr('onclick','$("#FirstPage").attr("sortby", "laneid"); $("#FirstPage").trigger("click"); return false;');
                return rowData.laneid;
            }
		},
		{
			width: 120,
			dataField: "direction",
			caption: DevExpress.localization.formatMessage("Direction"),
			visible: dir_visible,
			cellTemplate: function(element, info)
			{
				if (info.text == 0)
				{
					element.append(DevExpress.localization.formatMessage("No Direction"));
				}
				else if (info.text == 1)
				{
					element.append(DevExpress.localization.formatMessage("Coming"));
				}
				else if (info.text == -1)
				{
					element.append(DevExpress.localization.formatMessage("Going"));
				}
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-5').attr('onclick','$("#FirstPage").attr("sortby", "direction"); $("#FirstPage").trigger("click"); return false;');
                return rowData.direction;
            }
		},
		{
			width: 60,
			dataField: "globalconfidence",
			caption: DevExpress.localization.formatMessage("Conf."),
			calculateSortValue: function (rowData) {
				$('#dx-col-6').attr('onclick','$("#FirstPage").attr("sortby", "globalconfidence"); $("#FirstPage").trigger("click"); return false;');
                return rowData.globalconfidence;
            }
		}, ,
		{
			width: 100,
			dataField: "country",
			caption: DevExpress.localization.formatMessage("Country"),
			cellTemplate: function(element, info)
			{
				element.append(dict[info.text]);
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-7').attr('onclick','$("#FirstPage").attr("sortby", "country"); $("#FirstPage").trigger("click"); return false;');
                return rowData.country;
            }
		},
		{
			dataField: "listid",
			caption: DevExpress.localization.formatMessage("List"),
			width: 150,
			cellTemplate: function(element, info)
			{
				if (info.text != "[-1]")
				{
					var listastring = "";
					if (info.text.includes(";"))
					{
						var listas = info.text.split(";");
						$.each(listas, function(i, item)
						{
							listastring += dictlist[item] + ";";
						});
						listastring = listastring.slice(0, -1);
					}
					else
					{
						listastring = dictlist[info.text];
					}
					element.append(listastring);
				}
				else
				{
					element.append("");
				}
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-8').attr('onclick','$("#FirstPage").attr("sortby", "listid"); $("#FirstPage").trigger("click"); return false;');
                return rowData.listid;
            }
		},
		{
			dataField: "imageretailpath",
			caption: DevExpress.localization.formatMessage("Image"),
			width: 150,
			cellTemplate: function(element, info)
			{
				if (info.text != "")
				{
				    element.append("<img id='icimg" + info.key + "' src='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + info.text + localStorage.getItem("TOKEN") + "' height = '20' width='125'><div id='tooltip" + info.key + "'></div>")
					if (info.row.data.imagepath != "")
					{
						CreateToolTip(info.key, info.row.data.evidences, info.row.data.imagepath, info.row.data.resultleft, info.row.data.resulttop, info.row.data.resultright, info.row.data.resultbottom, info.row.data.width, info.row.data.height);
					}
				}
				else
				{
					element.append(DevExpress.localization.formatMessage("No image"));
				}
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-9').attr('onclick','$("#FirstPage").attr("sortby", "imageretailpath"); $("#FirstPage").trigger("click"); return false;');
                return rowData.imageretailpath;
            }
		},
		{
			dataField: "imagepath",
			caption: DevExpress.localization.formatMessage("Image"),
			width: 150,
			cellTemplate: function(element, info)
			{
				if (info.text != "")
				{
				    element.append("<a  href='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getfile&path=" + info.text + localStorage.getItem("TOKEN") + "'>LPR</a>")
					var i;
					for (i = 1; i <= info.row.data.evidences; i++)
					{
					    element.append("<a  href='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getfile&path=" + info.text.substring(0, info.text.length - 4) + "_ev" + i + ".jpg" + localStorage.getItem("TOKEN") + "'> EV" + i + "</a>")
					}
				}
				else
				{
					element.append(DevExpress.localization.formatMessage("No image"));
				}
			},
			calculateSortValue: function (rowData) {
				$('#dx-col-10').attr('onclick','$("#FirstPage").attr("sortby", "imagepath"); $("#FirstPage").trigger("click"); return false;');
                return rowData.imagepath;
            }
		}],
		onRowPrepared: function(row)
		{
			if (row.rowType == "data")
			{
				if (application == "eVivotek" || application == "eFastEdgeVivotek")
				{
					if (row.values[6] != "[-1]")
					{
						row.rowElement.addClass('Red');
					}
				}
				else
				{
					if (row.values[7] != "[-1]")
					{
						row.rowElement.addClass('Red');
					}
				}
			}
		}
	});

	function repeatSearchRequest(data_url)
	{
		var show_results = false;
		var json_parse = true;
		$.ajax(
		{
			dataType: "json",
			url: data_url,
			jsonp: false,
			timeout: 10000,
			cache: false,
			dataFilter: function(data, type)
			{
				CheckTokenValidity(data);
				try
				{
					console.log(JSON.parse(data));
				}
				catch (e)
				{
					data2.component.option("text", DevExpress.localization.formatMessage("Search"));
					$("#medium-indicator").hide();
					json_parse = false;
					if (DEFINE_INTERFACE == "ZKTECO")
					{
						confirm(DevExpress.localization.formatMessage("Cannot obtain the results"));
					}
					else
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("Cannot obtain the results"), "error", 1500);
						DevExpress.ui.notify(e.name + ": " + e.message, "error", 1500);
					}
				}
				if (json_parse)
				{
					json_data = JSON.parse(data);
				}
			},
			success: function(data, text_status, query)
			{
				show_results = true;
			},
			error: function(query, error_text_status, error_thrown)
			{
				if (error_text_status == "parsererror")
				{
					show_results = true;
					repeat_idx = 0;
				}
				else
				{
					if (repeat_idx < 5)
					{
						repeatSearchRequest(data_url);
						repeat_idx = repeat_idx + 1;
					}
					else
					{
						repeat_idx = 0;
						DevExpress.ui.notify(DevExpress.localization.formatMessage("Cannot obtain the results"), "error", 1500);
					}
				}
			},
			complete: function(query, text_status)
			{
				$("#medium-indicator").hide();
				if (show_results)
				{
					var dataGrid;
					if ($('#gridContainerReview').length == 0)
					{
						dataGrid = $('#gridContainer').dxDataGrid('instance');
					}
					else
					{
						dataGrid = $('#gridContainerReview').dxDataGrid('instance');
					}
					dataGrid.option('paging.pageSize', num_regs);
					page_actual = 1;
					num_pages = Math.ceil(num_registros_consulta / num_regs);
					$('#paginitas').dxTextBox('instance').option('value', DevExpress.localization.formatMessage("Pag.") + " " + page_actual + "/" + num_pages);
					if (num_pages > 1)
					{
						$("#PageAnt").show();
						$("#PageSig").show();
						$("#paginitas").show();
						$("#FirstPage").show();
						$("#LastPage").show();
					}
					dataGrid.option("dataSource", json_data);
				}
			}
		});
	}
});
